package Helpers;

import java.util.Date;


public class GrabberImage implements Comparable<GrabberImage> {
	public GrabberImage() {}
	// adressoflocalcopy: local file path to downloaded img
	// title: title of the image
	// description: description of image, if any (if none, null or "")
	// dateandtime: date and time when this image was uploaded on the original page
	// originalurl: the url of the original page/thread where this image was displayed, if any (if none, null or "")
	public GrabberImage(String AdressOfLocalCopy, String Title, String Description, Date DateAndTime, String OriginalUrl) {
		this.AdressOfLocalCopy = AdressOfLocalCopy;
		this.Title = (Title == null) ? "" : Title;
		this.Description = (Description != null && Description == "") ? null : Description;
		this.DateAndTime = DateAndTime;
		this.OriginalUrl = (OriginalUrl != null && OriginalUrl == "") ? null : OriginalUrl;
	}
	public String AdressOfLocalCopy;
	public String Description;
	public String Title;
	public String OriginalUrl;
	public Date DateAndTime;
	
	// for saving in a set or other sorting operations
	public int compareTo(GrabberImage arg0) {
		if (this.DateAndTime.after(arg0.DateAndTime)) return 1;
		if (arg0.DateAndTime.after(this.DateAndTime)) return -1;
		
		// time is the same. but object is most likely not. so let's just return the
		// comparison of the local name
		return this.AdressOfLocalCopy.compareTo(arg0.AdressOfLocalCopy);
	}
}
