package Helpers;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.TreeMap;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;

public class ProxyDialog {
	Dictionary dict = Dictionary.getInstance();
	TreeMap<String, String> mPropertiesMap;
	
	JFrame frame = null;
	JDialog dialog = null;
	
	JLabel lblHost = new JLabel(this.dict.getValue("ProxyDialog_lblHost"));
	JLabel lblPort = new JLabel(this.dict.getValue("ProxyDialog_lblPort"));
	JLabel lblUser = new JLabel(this.dict.getValue("ProxyDialog_lblUser"));
	JLabel lblPass = new JLabel(this.dict.getValue("ProxyDialog_lblPass"));
	
	JTextField tfdHost = new JTextField();
	JTextField tfdPort = new JTextField();
	JTextField tfdUser = new JTextField();
	JPasswordField pfdPass = new JPasswordField();
	
	JButton btnSave = new JButton(this.dict.getValue("ProxyDialog_btnSave"));
	JButton btnAbort = new JButton(this.dict.getValue("ProxyDialog_btnAbort"));
	
	JPanel pnlLabels = new JPanel();
	JPanel pnlTxtFields = new JPanel();
	JPanel pnlValues = new JPanel();
	JPanel pnlButtons = new JPanel();
	JPanel pnlAll = new JPanel();
	
	public TreeMap<String, String> getProperties() {
		return this.mPropertiesMap;
	}
	
	public ProxyDialog(JFrame f, TreeMap<String, String> mProps) {
		this.frame = f;
		this.mPropertiesMap = new TreeMap<String, String>();
		Iterator<String> iter = mProps.keySet().iterator();
		while(iter.hasNext()) {
			String sKey = iter.next();
			this.mPropertiesMap.put(sKey, mProps.get(sKey));
		}
	}
	
	public void showDialog() {
		this.dialog = new JDialog(this.frame, true); // modal
		this.dialog.setTitle(this.dict.getValue("ProxyDialog_Title"));
		this.dialog.setLocationRelativeTo(this.frame);
		
		this.pnlLabels.setLayout(new BoxLayout(this.pnlLabels, BoxLayout.Y_AXIS));
		this.pnlTxtFields.setLayout(new BoxLayout(this.pnlTxtFields, BoxLayout.Y_AXIS));
		this.pnlValues.setLayout(new BoxLayout(this.pnlValues, BoxLayout.X_AXIS));
		this.pnlButtons.setLayout(new BoxLayout(this.pnlButtons, BoxLayout.X_AXIS));
		this.pnlAll.setLayout(new BoxLayout(this.pnlAll, BoxLayout.Y_AXIS));
		
		this.tfdHost.setMinimumSize(new JLabel("xxxxxxxxxxxxxxxxxxxxx").getMinimumSize());
		this.tfdHost.setPreferredSize(new JLabel("xxxxxxxxxxxxxxxxxxxxx").getPreferredSize());
		this.tfdHost.setMaximumSize(new JLabel("xxxxxxxxxxxxxxxxxxxxx").getMaximumSize());
		this.tfdPort.setMinimumSize(new JLabel("xxxxxxxxxxxxxxxxxxxxx").getMinimumSize());
		this.tfdPort.setPreferredSize(new JLabel("xxxxxxxxxxxxxxxxxxxxx").getPreferredSize());
		this.tfdPort.setMaximumSize(new JLabel("xxxxxxxxxxxxxxxxxxxxx").getMaximumSize());
		this.tfdUser.setMinimumSize(new JLabel("xxxxxxxxxxxxxxxxxxxxx").getMinimumSize());
		this.tfdUser.setPreferredSize(new JLabel("xxxxxxxxxxxxxxxxxxxxx").getPreferredSize());
		this.tfdUser.setMaximumSize(new JLabel("xxxxxxxxxxxxxxxxxxxxx").getMaximumSize());
		this.pfdPass.setMinimumSize(new JLabel("xxxxxxxxxxxxxxxxxxxxx").getMinimumSize());
		this.pfdPass.setPreferredSize(new JLabel("xxxxxxxxxxxxxxxxxxxxx").getPreferredSize());
		this.pfdPass.setMaximumSize(new JLabel("xxxxxxxxxxxxxxxxxxxxx").getMaximumSize());
		
		if (!this.pfdPass.echoCharIsSet()) {
			this.pfdPass.setEchoChar('*');
		}
		
		if (this.mPropertiesMap != null && this.mPropertiesMap.size() != 0) {
			if (this.mPropertiesMap.containsKey("http.proxyHost")) {
				this.tfdHost.setText(this.mPropertiesMap.get("http.proxyHost"));
			}
			if (this.mPropertiesMap.containsKey("http.proxyPort")) {
				this.tfdPort.setText(this.mPropertiesMap.get("http.proxyPort"));
			}
			if (this.mPropertiesMap.containsKey("http.proxyUser")) {
				this.tfdUser.setText(this.mPropertiesMap.get("http.proxyUser"));
			}
			if (this.mPropertiesMap.containsKey("http.proxyPassword")) {
				this.pfdPass.setText(this.mPropertiesMap.get("http.proxyPassword"));
			}
		}
		
		this.btnAbort.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				ProxyDialog.this.mPropertiesMap = null;
				ProxyDialog.this.dialog.dispose();
				ProxyDialog.this.dialog.setVisible(false);
			}
		});
		this.btnSave.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				ProxyDialog.this.mPropertiesMap = new TreeMap<String, String>();
				ProxyDialog.this.mPropertiesMap.put("http.proxyHost", ProxyDialog.this.tfdHost.getText().trim());
				ProxyDialog.this.mPropertiesMap.put("http.proxyPort", ProxyDialog.this.tfdPort.getText().trim());
				ProxyDialog.this.mPropertiesMap.put("http.proxyUser", ProxyDialog.this.tfdUser.getText().trim());
				String sPass = new String(ProxyDialog.this.pfdPass.getPassword());
				ProxyDialog.this.mPropertiesMap.put("http.proxyPassword", sPass.trim());
				if (ProxyDialog.this.mPropertiesMap.get("http.proxyHost").equals("") || ProxyDialog.this.mPropertiesMap.get("http.proxyPort").equals("")) {
					JOptionPane.showMessageDialog(ProxyDialog.this.dialog, ProxyDialog.this.dict.getValue("ProxyDialog_ErrorMessage"),
							ProxyDialog.this.dict.getValue("ProxyDialog_ErrorTitle"), JOptionPane.ERROR_MESSAGE);
					return;
				}
				ProxyDialog.this.dialog.dispose();
				ProxyDialog.this.dialog.setVisible(false);
			}
		});
		
		this.pnlLabels.add(this.lblHost);
		this.pnlLabels.add(this.lblPort);
		this.pnlLabels.add(this.lblUser);
		this.pnlLabels.add(this.lblPass);
		
		this.pnlTxtFields.add(this.tfdHost);
		this.pnlTxtFields.add(this.tfdPort);
		this.pnlTxtFields.add(this.tfdUser);
		this.pnlTxtFields.add(this.pfdPass);
		
		this.pnlValues.add(this.pnlLabels);
		this.pnlValues.add(Box.createHorizontalGlue());
		this.pnlValues.add(this.pnlTxtFields);
		
		this.pnlButtons.add(this.btnSave);
		this.pnlButtons.add(Box.createHorizontalGlue());
		this.pnlButtons.add(this.btnAbort);
		
		this.pnlAll.add(Box.createVerticalGlue());
		this.pnlAll.add(this.pnlValues);
		this.pnlAll.add(this.pnlButtons);
		this.pnlAll.add(Box.createVerticalGlue());
		
		this.pnlAll.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10)); 
		this.dialog.add(this.pnlAll);
		this.dialog.setAlwaysOnTop(true);
		this.dialog.setSize(370, 160);
		this.dialog.setResizable(false);
		this.dialog.setVisible(true);
	}
}